//+------------------------------------------------------------------+
//|                                                 TradingTimes.mq4 |
//|                                                 Copyright  2007 |
//|                                                                  |
//+------------------------------------------------------------------+

// Add these inputs to your EA
extern int MagicID = 100;

extern string  sm0="--Trading Hours--";
extern string  sm1=" Times are GMT when UseDST=false";
extern bool    UseTradingHours = false;
extern string  sm2 = "GMT Offset default is for FXDD";
extern int     GMT_Offset = 3;
extern bool    UseDST = true;
extern bool    TradeAsianMarket = true;
extern int     myAsianStart = 2200;       // Start trades after time
extern int     myAsianStop = 100;      // Stop trading after time
extern bool    TradeEuropeanMarket = true;
extern int     myEurStart = 700;       // Start trades after time
extern int     myEurStop = 900;      // Stop trading after time
extern bool    TradeNewYorkMarket = false;
extern int     myNYStart = 1300;       // Start trades after time
extern int     myNYStop = 1500;      // Stop trading after time

// Add these variables to your EA

int      AsianStart;  // Start trades after time
int      AsianStop;      // Stop trading after time
int      EurStart;     // Start trades after time
int      EurStop;      // Stop trading after time
int      NYStart;     // Start trades after time
int      NYStop;      // Stop trading after time

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
     CorrectTimeFilterSettings();
     
     return(0);
}
  
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
int start()
  {
   int NumOrders = 0;
   bool YesStop;

   NumOrders = CalculateCurrentOrders();
   if(NumOrders == 0)
   {
      YesStop = false;
      if (UseTradingHours == true)
      {
        YesStop = CheckTradingTimes();
   
        if (YesStop == true)
        {
          Comment ("Trading has been stopped - wrong time of day");
        }
        else
        {
          Comment ("Trading has resumed");
        }
      }
              
      if (YesStop == false)
      {
// Your code for determine new trades and opening trades      
      }
   }
   else
   {
      // Your code to handle open positions
   }
}

  
void CorrectTimeFilterSettings()
{
   int TimeCorrection;
   
   TimeCorrection = 100 * GMT_Offset;
   if (UseDST == true)
   {
      TimeCorrection = TimeCorrection - 100;
   }
   
   
   AsianStart = myAsianStart + TimeCorrection;
   AsianStop = myAsianStop + TimeCorrection;
   EurStart = myEurStart + TimeCorrection;
   EurStop = myEurStop + TimeCorrection;
   NYStart = myNYStart + TimeCorrection;
   NYStop = myNYStop + TimeCorrection;
}

bool CheckTradingTimes()
{
   bool StopTrading;
   int ct;
   ct = Hour() * 100 + Minute();
   
     StopTrading = true;
// Check trading Asian Market
     if (TradeAsianMarket == true)
     {
        if (AsianStart > 1800)
        {
// Check broker that uses Asian open before 0:00

          if (ct >= AsianStart) StopTrading = false;
          if (StopTrading == false)
          {
            if (AsianStop < 2400)
            {
              if ( ct <= AsianStop) StopTrading = false;
            }
// These cannot be combined even though the code looks the same
            if (AsianStop >=0)
            {
              if ( ct <= AsianStop) StopTrading = false;
            }
          }
        }
        else
        {
          if (ct >= AsianStart && ct <= AsianStop) StopTrading = false;
        }
     }
     if (StopTrading == true)
     {
// Check trading European Market
       if (TradeEuropeanMarket == true)
       {
         if (ct >= EurStart && ct <= EurStop) StopTrading = false;
       }
     }
     if (StopTrading == true)
     {
// Check trading New York Market
       if (TradeNewYorkMarket == true)
       {
         if (ct >= NYStart && ct <= NYStop) StopTrading = false;
       }
     }
     
     return(StopTrading);
}

int CalculateCurrentOrders()
  {
   int buys = 0, sells = 0, num = 0;
   for(int i=0;i<OrdersTotal();i++)
     {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!= Symbol()) continue;
      if (OrderMagicNumber()!= MagicID) continue;
      if(OrderType() == OP_BUY)  buys++;
      if(OrderType() == OP_SELL) sells++;
     }
     
   num = buys + sells;
   return(num);
  }

//+------------------------------------------------------------------+